#include "stdio.h"

#include <avr/io.h>
#include <util/delay.h>


//#############################
//Globals
//#############################

#define LED_PORT (1<<5) 
#define LED_PIN PB5
#define BLINK_DELAY_MS 5000

//#############################
//Prototypes
//#############################

void led_blink(void);



//#############################
//MAIN
//#############################

int main(int argc, char **argv)
{ 
    led_blink();
     
    while(1) {
        led_blink();
        _delay_ms(500);
    }
    
    return 0;
}


//#############################
//FUNCTIONS
//#############################

/*
 * Input: None
 * Output: None
 * Description: Toggles the pin for the LED indicator.
 */
void led_blink(void) {
    //Set the DDR for output.
    DDRB |= LED_PORT;

    PORTB ^= (1<<LED_PIN);
    _delay_ms(500);
    PORTB ^= (1<<LED_PIN);
    _delay_ms(500);
    
}

